#include <iostream>
#include<vector>
#include <algorithm>
using namespace std;
unsigned long long PT(int k1,int k2,int k3,vector<int>x,vector<int>y){
  long long r=0;
int i=k3;
    int j=k1;
        r=r+(y[i]-y[j])*(x[i]+x[j]);
        i=j;
         i=k1;
     j=k2;
        r=r+(y[i]-y[j])*(x[i]+x[j]);
        i=j;
         i=k2;
     j=k3;
        r=r+(y[i]-y[j])*(x[i]+x[j]);

    return abs(r/2);
}
unsigned long long S(int n,vector<int>x,vector<int>y)
{
     long long r=0;
int i=n-1;
    for(int j=0;j<n;j++){
        r=r+(y[i]-y[j])*(x[i]+x[j]);
        i=j;
    }return abs(r/2);
}
int main()
{
    ios::sync_with_stdio(false);cin.tie(0);
int n;
unsigned long long r,m=0,pt;
cin>>n;
 vector<int>x(n);
    vector<int>y(n);
    for(int i=0;i<n;i++)cin>>x[i]>>y[i];
   // if(n>2000){
        r=S(n,x,y);
        for(int i=1;i<n-1;i++)
        {pt=PT(i-1,i,i+1,x,y);
        if(pt>m)m=pt;}
        pt=PT(n-2,n-1,0,x,y);
        if(pt>m)m=pt;
        pt=PT(n-1,0,1,x,y);
        if(pt>m)m=pt;
        cout<<r-m;

  //  }

    return 0;
}